import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCoachImgs, ThinkCoachImgsParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询教练组相册
 */
export async function pageThinkCoachImgs(params: ThinkCoachImgsParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCoachImgs>>>(
    THINK_API_URL + '/think/think-coach-imgs/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询教练组相册列表
 */
export async function listThinkCoachImgs(params?: ThinkCoachImgsParam) {
  const res = await request.get<ApiResult<ThinkCoachImgs[]>>(
    THINK_API_URL + '/think/think-coach-imgs',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加教练组相册
 */
export async function addThinkCoachImgs(data: ThinkCoachImgs) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-imgs',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改教练组相册
 */
export async function updateThinkCoachImgs(data: ThinkCoachImgs) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-imgs',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除教练组相册
 */
export async function removeThinkCoachImgs(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-imgs/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除教练组相册
 */
export async function removeBatchThinkCoachImgs(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-imgs/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询教练组相册
 */
export async function getThinkCoachImgs(id: number) {
  const res = await request.get<ApiResult<ThinkCoachImgs>>(
    THINK_API_URL + '/think/think-coach-imgs/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
